#delimit;
clear;
set more off;
set matsize 10000;
clear matrix;
clear mata;
set maxvar 10000;


*/----------------------------------------------------------------
	Replication file for 
		Casey, Glennerster and Miguel, "Reshaping Institutions," QJE 2012

	last modified by Kate 3 July 2013
------------------------------------------------------------------/;

*** SET YOUR DIRECTORY HERE ***;
cd  "C:\Users\kecasey\Dropbox\KECASEY\GBF_Stata\GBF_rep";

log using "gbf_replication_log.smcl", replace;

*/----------------------------------------------------------------
   #0. Set macros
------------------------------------------------------------------/;

* Independent variables: i) minimal set for endline only, ii) minimal set for panel, iii) full set for endline only, iv) full set for panel spec; 
	local min "t tothhs road ward_*"; 
	* --> NOTE: the minimum set of controls includes only the stratification (ward) and two balancing vars used in the randomization;
	local p_min "t post tp tothhs road ward_*"; 
	local full "t tothhs road yrseduc war slave chief elf_ea ward_*"; 
	* --> NOTE: the district dummy in the PAP is subsumed by the ward fixed effects;
	local p_full "tp t post tothhs road yrseduc war slave chief elf_ea ward_*";

* Dependent variables by hypothesis: CORE = full sample only, where "p" is for panel and "e" for endline only;
	local p_me_corevars_1 "vdc vis_wdc vis_lc met_councilor att_wdc";
	local e_me_corevars_1 "vdp bank_acct";
	local p_me_corevars_2 "f_psch f_phu f_well f_dryflr f_grnstr f_comcntr f_barrie f_palava f_market proposal";
	local e_me_corevars_2 "f_latrine func_tba func_sports seedbank footunif tarp_public no_bush days_brush";
	local p_me_corevars_3 "petty betteroff assets quintile tot_sources ";
	local e_me_corevars_3 "bank_acct tot_petty tot_goods tot_newbiz income training newbiz sold_agric sold_other out_trader";
	local p_me_corevars_7 "trust_own trust_out trust_chf trust_lc trust_cg osusu hwallet hmarket rmarket";
	local e_me_corevars_7 "trust_ngo trust_pol mkt_grp";
	local p_me_corevars_4 "wkcomfrm brush vdc proposal commfarm  commtchr";
	local e_me_corevars_4 "vchr_tot vchr_self anycard cards tarp tarp_freq mkt_grp no_bush days_brush";
	local p_me_corevars_8 "chumos dues ttch_oth  osusu mbr_pta mbr_soc"; 
	local e_me_corevars_8 "mbr_sav mbr_rel mbr_trad mbr_fish mbr_seed mbr_wom mbr_youth fishcoop mkt_grp"; 
	local p_me_corevars_9 "name_lc name_chr name_sc name_pc name_elec name_tax name_proj radio vis_wdc vis_lc disp_ind";
	local e_me_corevars_9 "gift_meet gift_two gift_choice info_gift info_tarp vis_pc";
	local p_me_corevars_5 "meet_com ";
	local e_me_corevars_5 "gift_meet wygift_meet proj_dem gift_dem gift_say tarp_say gift_big mtng_salt mtng_tarp mtng_cards dem_salt dem_tarp dem_cards say_salt say_tarp say_cards meet_tot meet_wmn meet_yth  spkr_tot spkr_wmn spkr_yth vote debate nohanghd noprivol democ  role_wmn role_yth duration maj_gift meet_salt equal_salt meet_tarp equal_tarp meet_cards equal_cards minutes disabled_meet disabled_ldr show_tarp store_tarp nocorrupt ben_salt ben_tarp tarp_public"; 
	local p_me_corevars_10 "vote_pres1 vote_local met_councilor att_wdc change_council change_chiefdom stand_pc stand_sc stand_lc stand_wdc vdc";
	local e_me_corevars_10 "cvote_pres1 vote_pres2 cvote_pres2 cvote_local discuss_politics council_listen vdp"; 
	local p_me_corevars_11 "nomon_conflict no_theft no_fight no_witch ";
	local e_me_corevars_11 "violence_bad nobeatwife nobeatchild no_conflict "; 
	local p_me_corevars_6 "resolve_nottrad trust_lc_chf";
	local e_me_corevars_6 "gift_say rtarp_public question_auth leader_wmn leader_yth proj_dem spend_lc_chf list_lc_chf notchf_salt notrad_salt notchf_tarp notrad_tarp notchf_cards notrad_cards vote chf_consult tstore_notchf not_trad_salt not_trad_tarp not_trad_card gift_who tarp_say tarp_stored"; 
	local e_me_corevars_12 "nobeatwife leader_yth leader_wmn bribebad strangeok noforcework youthtreat vh_fem vh_youth "; 

* Dependent variables by hypothesis: ALL = full sample + conditional outcomes;
	local p_me_allvars_1 "vdc vis_wdc vis_lc met_councilor att_wdc";
	local e_me_allvars_1 "vdp bank_acct wdc_psch wdc_phu wdc_tba wdc_well wdc_dryflr wdc_grnstr wdc_comcntr wdc_latrine wdc_sports";
	* --> For ME All H2: drop footequip cf_phu cf_grnstr cf_market cf_palava as insufficient obs to support standardization on controls and/or analysis;
	local p_me_allvars_2 "f_psch f_phu f_well f_dryflr f_grnstr f_comcntr f_palava f_barrie f_market proposal cf_psch cf_well cf_dryflr cf_comcntr cf_barrie";
	local e_me_allvars_2 "f_latrine func_tba func_sports seedbank footunif tarp_public no_bush days_brush smat_psch smat_lat smat_dry smat_well qual_psch qual_lat qual_dry qual_well  cf_latrine fin_tba fin_sports card_public";
	local p_me_allvars_3 "petty betteroff assets quintile tot_sources market_prod";
	local e_me_allvars_3 "bank_acct tot_petty out_trader tot_goods tot_newbiz income training newbiz sold_agric sold_other  ag_income school_days agric_out other_out";
	local p_me_allvars_7 "trust_own trust_out trust_chf trust_lc trust_cg osusu hwallet hmarket rmarket";
	local e_me_allvars_7 "trust_ngo trust_pol mkt_grp rwallet";
	* --> For ME All H4: drop cf_phu cf_grnstr cf_market as insufficient obs;
	local p_me_allvars_4 "wkcomfrm brush vdc proposal commfarm  commtchr train tchrpay tchrmoney  cf_psch cf_well cf_dryflr cf_comcntr cf_barrie daysfrm  bmon_osu bmon_lab bmon_pta lab_lab lab_pta";
	local e_me_allvars_4 "vchr_tot vchr_self anycard cards bmon_soc bmon_sav bmon_rel bmon_trad lab_osu lab_soc lab_sav lab_rel lab_trad cf_latrine fin_tba fin_sports  lab_psch lab_phu lab_tba lab_well lab_dryflr lab_grnstr lab_comcntr lab_latrine lab_sports  mat_psch mat_phu mat_tba mat_well mat_dryflr mat_grnstr mat_comcntr mat_latrine mat_sports tarp tarp_freq mkt_grp no_bush days_brush used_cards mat_back qual";
	local p_me_allvars_8 "chumos dues ttch_oth osusu mbr_pta mbr_soc ttch_own  meet_osu  meet_pta bmon_osu bmon_pta lab_pta";
 	local e_me_allvars_8 "mbr_sav mbr_rel mbr_trad meet_soc meet_sav bmon_soc bmon_sav bmon_rel bmon_trad lab_osu lab_soc lab_sav lab_rel lab_trad mbr_fish mbr_seed mbr_wom mbr_youth meet_rel meet_trad meet_fish meet_seed meet_wom meet_youth bmon_fish bmon_seed bmon_wom bmon_youth lab_fish lab_seed lab_wom lab_youth fishcoop mkt_grp"; 
	local p_me_allvars_9 "name_lc name_chr name_sc name_pc name_elec name_tax name_proj radio name_dues vis_wdc vis_lc disp_ind";
	local e_me_allvars_9 "gift_meet gift_two gift_choice info_gift info_tarp info_cards vis_pc";
	local p_me_allvars_5 "meet_com meet_osu meet_lab meet_pta meet_tchr meet_farm spk_com spk_tchr spk_farm"; 
	local e_me_allvars_5 "gift_meet wygift_meet spk_gift proj_dem gift_dem gift_say tarp_say gift_big meet_soc meet_rel meet_sav meet_trad mtng_salt mtng_tarp mtng_cards dem_salt dem_tarp dem_cards say_salt say_tarp say_cards spk_salt spk_tarp spk_cards mtng_psch mtng_phu mtng_tba mtng_well mtng_dryflr mtng_grnstr mtng_comcntr mtng_latrine mtng_sports meet_tot meet_wmn meet_yth  spkr_tot spkr_wmn spkr_yth vote debate nohanghd noprivol democ  role_wmn role_yth duration maj_gift inc_hh pwy_hh meet_salt equal_salt meet_tarp equal_tarp meet_cards equal_cards minutes disabled_meet disabled_ldr show_tarp store_tarp nocorrupt ben_salt ben_tarp tarp_public rcpt_cards recd_cards goods_show show_mat store_mat ben_cards card_public wide_pay"; 
	local p_me_allvars_10 "vote_pres1 vote_local met_councilor att_wdc change_council change_chiefdom stand_pc stand_sc stand_lc stand_wdc vdc"; 
	local e_me_allvars_10 "vote_pres2 cvote_pres1 cvote_pres2 cvote_local discuss_politics council_listen wannabe_VDC chf_psch chf_phu chf_tba chf_well chf_dryflr chf_grnstr chf_comcntr chf_latrine chf_sports wdc_psch wdc_phu wdc_tba wdc_well wdc_dryflr wdc_grnstr wdc_comcntr wdc_latrine wdc_sports vdc_wmn vdc_yth vdp vdp_writ vdp_tarp vdp_mat"; 
	local p_me_allvars_11 "nomon_conflict no_theft no_fight no_witch nomon_violence"; 
	local e_me_allvars_11 "violence_bad nobeatwife nobeatchild no_conflict resolve_within"; 
	local p_me_allvars_6 "resolve_nottrad trust_lc_chf tchr_dec tchr_rep"; 
	local e_me_allvars_6 "gift_say rtarp_public question_auth leader_wmn leader_yth proj_dem spend_lc_chf list_lc_chf notchf_salt notrad_salt notchf_tarp notrad_tarp notchf_cards notrad_cards vote chf_consult tstore_notchf mstore_pub send_not_trad not_trad_salt not_trad_tarp not_trad_card gift_who tarp_say tarp_stored"; 
	local p_me_allvars_12 "osusu_ind labgang_ind frm_sex frm_age frm_nokid frm_trb"; 
	local e_me_allvars_12 "nobeatwife leader_yth leader_wmn bribebad strangeok noforcework youthtreat socialc_ind groupsave_ind religgroup_ind tradsoc_ind vh_fem vh_youth"; 

* Flag output for Table 4 (Selected significant results for H1-3), Table 5 (Selected results from the SCAs) and Table 6 (Cherry picking);
	local allvars_40 "vdc vis_wdc vdp bank_acct wdc_psch wdc_dryflr wdc_latrine func_tba f_latrine f_comcntr proposal smat_psch smat_dry smat_lat tot_petty tot_goods assets training"; 
	local allvars_50 "anycard cards meet_cards duration meet_tot meet_wmn meet_yth spkr_tot spkr_wmn spkr_yth vote meet_tarp store_tarp tarp tarp_public ben_tarp";
	local allvars_60 "mtng_tarp equal_tarp show_tarp wannabe_VDC vote_local train mbr_wom minutes store_mat notrad_tarp leader_yth name_elec";
	
	local core_sca1 "anycard cards vchr_self vchr_tot know_cards dem_cards equal_cards meet_cards mtng_cards say_cards not_trad_card notchf_cards notrad_cards ben_cards card_public store_mat wide_pay";
	local core_sca2 "gift_choice gift_meet gift_two info_gift debate dem_salt democ duration equal_salt gift_big gift_dem gift_say maj_gift meet_salt meet_tot meet_wmn meet_yth mtng_salt nohanghd noprivol role_wmn role_yth say_salt spkr_tot spkr_wmn spkr_yth vote chf_consult gift_who not_trad_salt notchf_salt notrad_salt ben_salt";
	local core_sca3 "tarp_public tarp tarp_freq info_tarp dem_tarp equal_tarp meet_tarp mtng_tarp say_tarp show_tarp store_tarp tarp_say not_trad_tarp notchf_tarp notrad_tarp tarp_stored tstore_notchf  ben_tarp ";
	
*/----------------------------------------------------------------
  #1. TABLE 1. Selected Baseline T/C Differences at village level
------------------------------------------------------------------/;

use  "gbf_analysis.dta", clear;
keep if post==0;
keep t r_ward bombali tothhs war road slave yrsed vdc f_psch f_dryflr vis_wdc assets petty  betteroff  trust_chf trust_lc osusu fem_spk_com male_spk_com vote_local;

* 2 balancing vars as outcomes need to be run separately;
areg tothhs t road, absorb(r_ward) robust;
sum tothhs if t==0;
areg road t tothhs, absorb(r_ward) robust;
sum road if t==0;

foreach var of varlist war slave yrsed vdc vis_wdc f_dryflr f_psch assets petty trust_chf trust_lc osusu male_spk_com fem_spk_com vote_local {;
		gen te_`var'=.;
		gen se_`var'=.;
		gen p_`var'=.;
		gen N_`var'=.;
		gen cm_`var'=.;
		areg `var' t tothhs road, absorb(r_ward) robust;
		replace te_`var'=_b[t];
		replace se_`var'=_se[t];
		replace p_`var'=2*(1-normal(abs(te_`var'/ se_`var')));
		replace N_`var'=e(N);
		ttest `var', by(t);
		replace cm_`var'=r(mu_1);
		};
gen n=_n;
keep if n==1;

* Reshape and tidy;
keep n te_* se_* p_* N_* cm_*;
reshape long te_ se_ p_ N_ cm_, i(n) j(x) string;
drop n; 
gen signif=.;
replace signif=.90 if  p_<.1;
replace signif=.95 if  p_<.05;
replace signif=.99 if  p_<.01;
drop p_;
order  x cm_ te_ se_ signif N_;
format  %9.2f te se cm;

rename x variable;
rename  te_ treat_effect_base;
rename  se_ treat_stderr_base;
rename  cm_ mean_control_base;
rename  N_ N_base;

*** Table 1 (outcomes in alphabetical order) ***;
list variable mean_control_base treat_effect_base treat_stderr_base signif N_base;


outsheet using "tab1", replace;



*/----------------------------------------------------------------
  #2. TABLE 2 COLS 1 and 2: Primary specification for mean treatment 
		effect indices hypothesis and by family (Col 1) and accompanying
		"naive" p-values (Col 2)
       	- Endline data ONLY
		- Minimal controls ONLY
		- Using Z-score approach to ME Index (Kling, Liebman & Katz 2007)
		- Full sample outcomes ONLY
------------------------------------------------------------------/;

use "gbf_analysis.dta", clear;

drop if post==0;

foreach num of numlist 1 2 3 4 7 8 9 10 11 12{;
	local i = `num';
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		local zscore_string_`i'="`zscore_string_`i''" + " std_`i'_`l'";
			};
	egen zscore_`i'=rowmean(`zscore_string_`i'');
	local zscore_string_`i'="";
	local l = 0;
	drop *_mean *_sd mean_std_*;
	};

* NOTE: large number of outcomes in H5 and H6 require longer strings hand coded below;	
	
foreach num of numlist 5 6{; 
	local i = `num';
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		};
	local l = 0;
	drop *_mean *_sd mean_std_*;
	};

egen zscore_5=rowmean( std_5_1 std_5_2 std_5_3 std_5_4 std_5_5 std_5_6 std_5_7 std_5_8 std_5_9 std_5_10 std_5_11 std_5_12 std_5_13 std_5_14 std_5_15 std_5_16 std_5_17 std_5_18 std_5_19 std_5_20 std_5_21 std_5_22 std_5_23 std_5_24 std_5_25 std_5_26 std_5_27 std_5_28 std_5_29 std_5_30 std_5_31 std_5_32 std_5_33 std_5_34 std_5_35 std_5_36 std_5_37 std_5_38 std_5_39 std_5_40 std_5_41 std_5_42 std_5_43 std_5_44 std_5_45 std_5_46 std_5_47);
egen zscore_6=rowmean( std_6_1 std_6_2 std_6_3 std_6_4 std_6_5 std_6_6 std_6_7 std_6_8 std_6_9 std_6_10 std_6_11 std_6_12 std_6_13 std_6_14 std_6_15 std_6_16 std_6_17 std_6_18 std_6_19 std_6_20 std_6_21 std_6_22 std_6_23 std_6_24 std_6_25);
	
* NOTE: pull out zscores for FWER adjustment below in #4;	
preserve;
keep id_vill t tothhs road ward_* zscore_*;
save "zscores.dta", replace;
restore;
	
	
foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12{;
	reg  zscore_`num' t tothhs road ward_*, robust;
	display "Hypothesis number in Table= `num'";
	estimates store tab2col1_h`num';
};
	estout tab2col1_h* using "tab2_cols1_2", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;


* Drop duplicates - i.e. outcomes that appear under more than 1 hypothesis within a family (Fam A has 39 unique outcomes in total, Fam B has 155 unique);
drop std_3_6; * bank account;
drop std_4_13 std_8_15 std_5_2 std_10_11 std_6_3 std_6_8 std_6_17 std_6_24 std_12_1 std_12_2 std_12_3; * mkt_grp(x2), gift_meet, vdc, gift_say, proj_dem, vote, tarp_say, nobeatwife, leader_yth, leader_wmn;

egen zscore_fam_a=rowmean(std_1_* std_2_* std_3_*);
egen zscore_fam_b=rowmean(std_4_* std_5_* std_6_* std_7_* std_8_* std_9_* std_10_* std_11_* std_12_*);
reg  zscore_fam_a t tothhs road ward_*, robust;
reg  zscore_fam_b t tothhs road ward_*, robust;



*/----------------------------------------------------------------
  #3. APPENDIX K: Interactions for TE Heterogeneity by Family 
	(same as main spec above in #2)
 	- Endline data ONLY
	- Minimal controls ONLY
	- Using Z-score approach to ME Index (Kling, Liebman & Katz 2007)
	- Full sample outcomes ONLY
------------------------------------------------------------------/;

foreach var of varlist tothhs war yrsedu road slave bombali elf_ea chief{;
	gen `var'_t=`var'*t;
	};
	
	
foreach x in a b{;
	reg zscore_fam_`x' t tothhs war yrseduc road slave elf_ea chief tothhs_t war_t yrseduc_t road_t slave_t bombali_t elf_ea_t chief_t ward_*, robust;
	estimates store appl_`x'_hetero;
		};
	estout appl_* using "appendix_K", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;

	estimates drop _all;


*/----------------------------------------------------------------
#4. TABLE 2 COLUMNS 3 and 4: FWER adjustment to p-values 
	- Westfall and Young 1993 free step-down resampling procedure
	- Code adapted from Michael Anderson (see http://are.berkeley.edu/~mlanderson)
	- Column 3 runs for all 12 hypotheses
	- Column 4 runs for original 11 hypotheses in 2009 PAP
------------------------------------------------------------------/;

use "zscores.dta", clear;

* generate variables to store actual and simulated t-stats/p-vals ;

local counter = 1;
gen str20 varname = "";
gen float tstat = .;
gen float act_pval = .;
gen float tstatsim = .;
gen float pvalsim = .;
gen float pvals = .;

* run the original regressions for all of the different outcomes tested and store the actual (observed) p-vals/t-stats;

foreach lhsvar in  zscore_1 zscore_2 zscore_3 zscore_4 zscore_5 zscore_6 zscore_7 zscore_8 zscore_9 zscore_10 zscore_11 zscore_12 {;
    quietly reg `lhsvar' t tothhs road ward_*;
    quietly replace tstat = abs(_b[t]/_se[t]) in `counter';
    quietly replace act_pval = 2*ttail(e(N),abs(tstat)) in `counter';
    quietly replace varname = "`lhsvar'" in `counter';
    local `lhsvar'_ct_0 = 0;
    local counter = `counter' + 1;
    };

* sort the p-vals by the actual (observed) p-vals (this will reorder some of the obs, but that shouldn't matter);

gsort act_pval;
local endvar = `counter' - 1;

* generate the variable that will contain the simulated (placebo) treatments;

gen byte simtreatment = .;
gen float simtreatment_uni = .;
local count = 1;

* run 10,000 iterations of the simulation, record results in p-val storage counters;
while `count' <= 10000 {;
* in this section we assign the placebo treatments and run regressions using the placebo treatments;
	quietly replace simtreatment_uni = uniform();
	quietly replace simtreatment = (simtreatment_uni>0.5);
	quietly replace tstatsim = .;
	quietly replace pvalsim = .;
	foreach lhsvar of numlist 1/`endvar' {;
	    local depvar = varname[`lhsvar'];
        quietly reg `depvar' simtreatment tothhs road ward_*;
	   	quietly replace tstatsim = abs(_b[simtreatment]/_se[simtreatment]) in `lhsvar';
        quietly replace pvalsim = 2*ttail(e(N),abs(tstatsim)) in `lhsvar';
    	};
* in this section we perform the "step down" procedure that replaces simulated p-vals with the minimum of the set of simulated p-vals associated with outcomes that had actual p-vals greater than or equal to the one being replaced.  For each outcome, we keep count of how many times the ultimate simulated p-val is less than the actual observed p-val.;
    local countdown = `endvar';
    while `countdown' >= 1 {;
        quietly replace pvalsim = min(pvalsim,pvalsim[_n+1]) in `countdown';
        local depvar = varname[`countdown'];
        if pvalsim[`countdown'] <= act_pval[`countdown'] {;
            local `depvar'_ct_0 = ``depvar'_ct_0' + 1;
            };
        local countdown = `countdown' - 1;
    	};
    local count = `count' + 1;
    };

* perform the final adjustment that ensures that the ordering to adjusted p-vals is the same as the original ordering of actual p-vals.  note that this is actually a "step up" procedure rather than a "step down";
foreach lhsvar of numlist 1/`endvar' {;
    local depvar = varname[`lhsvar'];
    quietly replace pvals = max(round(``depvar'_ct_0'/10000,.001), pvals[`lhsvar'-1]) in `lhsvar';
    };
* NOTE: FWER pvals for Table 2 Col 3 below.  Since the simulations are not seeded, the exact pvals calculated will differ by simulation;
list varname pvals if varname!="";




*** Repeat for Column 4, dropping hypo 1***;
use "zscores.dta", clear;

* generate variables to store actual and simulated t-stats/p-vals ;

local counter = 1;
gen str20 varname = "";
gen float tstat = .;
gen float act_pval = .;
gen float tstatsim = .;
gen float pvalsim = .;
gen float pvals = .;

* run the original regressions for all of the different outcomes tested and store the actual (observed) p-vals/t-stats;

foreach lhsvar in zscore_2 zscore_3 zscore_4 zscore_5 zscore_6 zscore_7 zscore_8 zscore_9 zscore_10 zscore_11 zscore_12 {;
    quietly reg `lhsvar' t tothhs road ward_*;
    quietly replace tstat = abs(_b[t]/_se[t]) in `counter';
    quietly replace act_pval = 2*ttail(e(N),abs(tstat)) in `counter';
    quietly replace varname = "`lhsvar'" in `counter';
    local `lhsvar'_ct_0 = 0;
    local counter = `counter' + 1;
    };

* sort the p-vals by the actual (observed) p-vals (this will reorder some of the obs, but that shouldn't matter);

gsort act_pval;
local endvar = `counter' - 1;

* generate the variable that will contain the simulated (placebo) treatments;

gen byte simtreatment = .;
gen float simtreatment_uni = .;
local count = 1;

* run 10,000 iterations of the simulation, record results in p-val storage counters;
while `count' <= 10000 {;
* in this section we assign the placebo treatments and run regressions using the placebo treatments;
	quietly replace simtreatment_uni = uniform();
	quietly replace simtreatment = (simtreatment_uni>0.5);
	quietly replace tstatsim = .;
	quietly replace pvalsim = .;
	foreach lhsvar of numlist 1/`endvar' {;
	    local depvar = varname[`lhsvar'];
        quietly reg `depvar' simtreatment tothhs road ward_*;
	   	quietly replace tstatsim = abs(_b[simtreatment]/_se[simtreatment]) in `lhsvar';
        quietly replace pvalsim = 2*ttail(e(N),abs(tstatsim)) in `lhsvar';
    	};
* in this section we perform the "step down" procedure that replaces simulated p-vals with the minimum of the set of simulated p-vals associated with outcomes that had actual p-vals greater than or equal to the one being replaced.  For each outcome, we keep count of how many times the ultimate simulated p-val is less than the actual observed p-val.;
    local countdown = `endvar';
    while `countdown' >= 1 {;
        quietly replace pvalsim = min(pvalsim,pvalsim[_n+1]) in `countdown';
        local depvar = varname[`countdown'];
        if pvalsim[`countdown'] <= act_pval[`countdown'] {;
            local `depvar'_ct_0 = ``depvar'_ct_0' + 1;
            };
        local countdown = `countdown' - 1;
    	};
    local count = `count' + 1;
    };

* perform the final adjustment that ensures that the ordering to adjusted p-vals is the same as the original ordering of actual p-vals.  note that this is actually a "step up" procedure rather than a "step down";
foreach lhsvar of numlist 1/`endvar' {;
    local depvar = varname[`lhsvar'];
    quietly replace pvals = max(round(``depvar'_ct_0'/10000,.001), pvals[`lhsvar'-1]) in `lhsvar';
    };

* NOTE: FWER pvals for Table 2 Col 4 below.  Since the simulations are not seeded, the exact pvals calculated will differ by simulation;	
list varname pvals if varname!="";

erase "zscores.dta";


*/----------------------------------------------------------------
	#5. TABLE 3 COL 1: Covariance weighted mean effects index
		- Endline data ONLY
		- Minimal controls ONLY
		- Using var-covar weighting approach to ME Index (Anderson 2008)
		- Full sample outcomes ONLY
------------------------------------------------------------------/;

use "gbf_analysis.dta", clear;

drop if post==0;

foreach num of numlist 1 2 3 4 7 8 9 10 11 12{;
local i = `num';
	* 1. Convert outcomes to effect sizes;
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		local matrix_string_`i'="`matrix_string_`i''" + " std_`i'_`l'";
		};
		local k = `l';
		save "mei_std_h`i'.dta", replace;
		
	* 2. Construct matrix and component weights using controls only;
	drop if t==1;
	
		forvalues x = 1/`k' {;
			gen weight`x'_`i'=0;
			};
	
		matrix accum R = `matrix_string_`i'', nocons dev;	
		matrix R=R/r(N);
		matrix R=invsym(R);
		local counter1=1;
		matrix J = J(colsof(R), 1, 1);
		while `counter1'<=colsof(R){;
			matrix T = R[`counter1', 1..colsof(R)];
			matrix A = T*J;
			qui replace weight`counter1'_`i'=A[1,1];
			qui replace weight`counter1'_`i'=0 if weight`counter1'_`i'<0;
			local counter1 = `counter1'+1;
			};
			
		gen sample_h`i'=0;	
		forvalues x = 1/`k' {;
			qui replace sample_h`i'=sample_h`i'+weight`x'_`i';
			};
		keep sample_h`i' weight*;
		collapse _all;
				
		cross using "mei_std_h`i'.dta";
			
	* 3. Apply weights and construct index;
		qui gen outcome_h`i'=0;
			forvalues x = 1/`k' {;
			qui replace outcome_h`i'=std_`i'_`x'*(weight`x'_`i') + outcome_h`i';
			};
			qui replace outcome_h`i'=outcome_h`i'/sample_h`i';			
		local l = 0;
		drop *_mean *_sd mean_std_*;
};
	* 4. Estimate treatment effects;
		foreach num of numlist 1 2 3 4 7 8 9 10 11 12{;
			reg outcome_h`num' t tothhs road ward_*;
			estimates store ander_`num';
			};
			
			
*** Run separately for Hypo 5 since it covers too many outcomes for matrix string;
use "gbf_analysis.dta", clear;

drop if post==0;

	local i = 5;
		* 1. Convert outcomes to effect sizes;
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		};
		local k = `l';
		save "mei_std_h`i'.dta", replace;
			
	* 2. Construct matrix and component weights;
	drop if t==1;
		forvalues x = 1/`k' {;
			gen weight`x'_`i'=0;
			};
	    matrix accum R =std_5_1 std_5_2 std_5_3 std_5_4 std_5_5 std_5_6 std_5_7 std_5_8 std_5_9 std_5_10 std_5_11 std_5_12 std_5_13 std_5_14 std_5_15 std_5_16 std_5_17 std_5_18 std_5_19 std_5_20 std_5_21 std_5_22 std_5_23 std_5_24 std_5_25 std_5_26 std_5_27 std_5_28 std_5_29 std_5_30 std_5_31 std_5_32 std_5_33 std_5_34 std_5_35 std_5_36 std_5_37 std_5_38 std_5_39 std_5_40 std_5_41 std_5_42 std_5_43 std_5_44 std_5_45 std_5_46 std_5_47, nocons dev;	
		matrix R=R/r(N);
		matrix R=invsym(R);
		local counter1=1;
		matrix J = J(colsof(R), 1, 1);
		while `counter1'<=colsof(R){;
			matrix T = R[`counter1', 1..colsof(R)];
			matrix A = T*J;
			qui replace weight`counter1'_`i'=A[1,1];
			qui replace weight`counter1'_`i'=0 if weight`counter1'_`i'<0;
			local counter1 = `counter1'+1;
			};
			
		gen sample_h`i'=0;	
		forvalues x = 1/`k' {;
			qui replace sample_h`i'=sample_h`i'+weight`x'_`i';
			};
			
		keep sample_h`i' weight*;
		collapse _all;
		cross using "mei_std_h`i'.dta";	
			
	* 3. Apply weights and construct index;
		qui gen outcome_h`i'=0;
			forvalues x = 1/`k' {;
			qui replace outcome_h`i'=std_`i'_`x'*(weight`x'_`i') + outcome_h`i';
			};
			qui replace outcome_h`i'=outcome_h`i'/sample_h`i';			
		local l = 0;
		drop *_mean *_sd mean_std_*;
		
	* 4. Estimate treatment effects;
		reg outcome_h`i' t tothhs road ward_*;
		estimates store ander_`i';

*** Run separately for Hypo 6 since it covers too many outcomes for matrix string;
use "gbf_analysis.dta", clear;

drop if post==0;

	local i = 6;
		* 1. Convert outcomes to effect sizes;
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		};
		local k = `l';
		save "mei_std_h`i'.dta", replace;
			
	* 2. Construct matrix and component weights;
	drop if t==1;
		forvalues x = 1/`k' {;
			gen weight`x'_`i'=0;
			};
		matrix accum R = std_6_1 std_6_2 std_6_3 std_6_4 std_6_5 std_6_6 std_6_7 std_6_8 std_6_9 std_6_10 std_6_11 std_6_12 std_6_13 std_6_14 std_6_15 std_6_16 std_6_17 std_6_18 std_6_19 std_6_20 std_6_21 std_6_22 std_6_23 std_6_24 std_6_25, nocons dev;
		matrix R=R/r(N);
		matrix R=invsym(R);
		local counter1=1;
		matrix J = J(colsof(R), 1, 1);
		while `counter1'<=colsof(R){;
			matrix T = R[`counter1', 1..colsof(R)];
			matrix A = T*J;
			qui replace weight`counter1'_`i'=A[1,1];
			qui replace weight`counter1'_`i'=0 if weight`counter1'_`i'<0;
			local counter1 = `counter1'+1;
			};
			
		gen sample_h`i'=0;	
		forvalues x = 1/`k' {;
			qui replace sample_h`i'=sample_h`i'+weight`x'_`i';
			};
			
		keep sample_h`i' weight*;
		collapse _all;
		cross using "mei_std_h`i'.dta";	
			
	* 3. Apply weights and construct index;
		qui gen outcome_h`i'=0;
			forvalues x = 1/`k' {;
			qui replace outcome_h`i'=std_`i'_`x'*(weight`x'_`i') + outcome_h`i';
			};
			qui replace outcome_h`i'=outcome_h`i'/sample_h`i';			
		local l = 0;
		drop *_mean *_sd mean_std_*;
		
	* 4. Estimate treatment effects;
		reg outcome_h`i' t tothhs road ward_*;
		estimates store ander_`i';

estout ander_* using "tab3_col1", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;

forval x=1/12{;
	erase "mei_std_h`x'.dta";
	};


*/----------------------------------------------------------------
	#6. TABLE 3 COL 2: SUR approach to Mean Effects Index
	- Endline data ONLY
	- Minimal controls ONLY
	- Using SUR approach to ME Index (Kling & Liebman 2004)
	- Full sample outcomes ONLY
------------------------------------------------------------------/;

use "gbf_analysis.dta", clear;

drop if post==0;

foreach num of numlist 1 2 3 4 7 8 9 10 11 12{;
	local i = `num'; 	
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		};
	foreach var of varlist `p_me_corevars_`i'' `e_me_corevars_`i''{; 
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	local n=wordcount("`p_me_corevars_`i''");
	local m=wordcount("`e_me_corevars_`i''");
	local k = `n' + `m';
		forvalues p = 1/`k'{;
		local nlcom_string_`i'="`nlcom_string_`i''" + "`plus'" + "[e`p'_mean]t";
		local plus = " +";			
		};	
	nlcom ((`nlcom_string_`i'')/`k'), post;
	estimates store tab3_col2_h`i';
	estout tab3_col2_h`i' using "tab3_col2_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;
};

*** Run separately for Hypo 5 since it covers too many outcomes for nlcom automated string compilation;	
use "gbf_analysis.dta", clear;

drop if post==0;

local i = 5; 	
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		};
	foreach var of varlist `p_me_corevars_`i'' `e_me_corevars_`i''{; 
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t + [e34_mean]t+ [e35_mean]t + [e36_mean]t+[e37_mean]t+[e38_mean]t+[e39_mean]t+[e40_mean]t+[e41_mean]t+[e42_mean]t+[e43_mean]t+[e44_mean]t+[e45_mean]t+[e46_mean]t+[e47_mean]t) /47), post;
	estimates store tab3_col2_h`i';
	estout tab3_col2_h`i' using "tab3_col2_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;
	
	
	
*** Run separately for Hypo 6 since it covers too many outcomes for nlcom automated string compilation;	
use "gbf_analysis.dta", clear;

drop if post==0;

local i = 6; 	
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		};
	foreach var of varlist `p_me_corevars_`i'' `e_me_corevars_`i''{; 
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t) /25), post;
	estimates store tab3_col2_h`i';
	estout tab3_col2_h`i' using "tab3_col2_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;

*/-----------------------------------------------
	#7: TABLE 3 COL 3: Mean effects index with panel data
	- PANEL data where available
	- Minimal controls ONLY
	- Using SUR approach to ME Index (Kling & Liebman 2004)
	- Full sample outcomes ONLY
-----------------------------------------------/;

*** A. NOTE: this is for those H with both panel and non-panel data in the CORE outcome set;

use "gbf_analysis.dta", clear;

foreach num of numlist 1 2 3 4 7 8 9 10 11 {;
	local i = `num'; 	
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		};
	foreach var of varlist  `p_me_corevars_`i''{; 
		qui reg `var'_std `p_min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	foreach var of varlist  `e_me_corevars_`i''{; 
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	local n=wordcount("`p_me_corevars_`i''");
	local m=wordcount("`e_me_corevars_`i''");
	local k = `n' + `m';
	local l = `n' + 1;
		forvalues p = 1/`n'{;
		local nlcom_string_`i'="`nlcom_string_`i''" + "`plus'" + "[e`p'_mean]tp";
		local plus = " +";
			};
		forvalues p = `l'/`k'{;
		local nlcom_string_`i'="`nlcom_string_`i''" + "`plus'" + "[e`p'_mean]t";
			};	
	nlcom ((`nlcom_string_`i'')/`k'), post;
	estimates store me_core_`i';
	estout me_core_`i' using "tab3_col3_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;
};


*** B. NOTE: this is for H12 with ONLY non-panel data in the CORE outcome set;
use "gbf_analysis.dta", clear;
foreach num of numlist 12{;
	local i = `num'; 	
	foreach var of varlist `e_me_corevars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	local k=wordcount("`e_me_corevars_`i''");
		forvalues p = 1/`k'{;
		local nlcom_string_`i'="`nlcom_string_`i''" + "`plus'" + "[e`p'_mean]t";
		local plus = " +";
			};
	nlcom ((`nlcom_string_`i'')/`k'), post;
	estimates store me_core_`i';
	estout me_core_`i' using "tab3_col3_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;
};



*** C. ME Core for H5 with large # of outcomes;
use "gbf_analysis.dta", clear;

local i = 5; 
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		};
	foreach var of varlist  `p_me_corevars_`i''{; 
		qui reg `var'_std `p_min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	foreach var of varlist  `e_me_corevars_`i''{; 
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]tp+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t + [e34_mean]t+ [e35_mean]t + [e36_mean]t+[e37_mean]t+[e38_mean]t+[e39_mean]t+[e40_mean]t+[e41_mean]t+[e42_mean]t+[e43_mean]t+[e44_mean]t+[e45_mean]t+[e46_mean]t+[e47_mean]t) /47), post;
	estimates store me_core_`i';
	estout me_core_`i' using "tab3_col3_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;	


*** D. ME Core for H6 with large # of outcomes;
use "gbf_analysis.dta", clear;

local i = 6;
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		};
	foreach var of varlist  `p_me_corevars_`i''{; 
		qui reg `var'_std `p_min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	foreach var of varlist  `e_me_corevars_`i''{; 
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]tp+[e2_mean]tp+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t) /25), post;
	estimates store me_core_`i';
	estout me_core_`i' using "tab3_col3_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;	

*/----------------------------------------------------------------
  #8. TABLE 3 COL 4: Mean Effects Index with full controls
 	- Endline data ONLY
	- Full set of controls 
	- Using Z-score approach to ME Index (Kling, Liebman & Katz 2007)
	- Full sample outcomes ONLY
------------------------------------------------------------------/;

use "gbf_analysis.dta", clear;
drop if post==0;

foreach num of numlist 1 2 3 4 7 8 9 10 11 12{;
	local i = `num';
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		local zscore_string_`i'="`zscore_string_`i''" + " std_`i'_`l'";
			};
	egen zscore_`i'=rowmean(`zscore_string_`i'');
	local zscore_string_`i'="";
	local l = 0;
	drop *_mean *_sd mean_std_*;
	};

foreach num of numlist 5 6{;
	local i = `num';
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		};
	local l = 0;
	drop *_mean *_sd mean_std_*;
	};


egen zscore_5=rowmean( std_5_1 std_5_2 std_5_3 std_5_4 std_5_5 std_5_6 std_5_7 std_5_8 std_5_9 std_5_10 std_5_11 std_5_12 std_5_13 std_5_14 std_5_15 std_5_16 std_5_17 std_5_18 std_5_19 std_5_20 std_5_21 std_5_22 std_5_23 std_5_24 std_5_25 std_5_26 std_5_27 std_5_28 std_5_29 std_5_30 std_5_31 std_5_32 std_5_33 std_5_34 std_5_35 std_5_36 std_5_37 std_5_38 std_5_39 std_5_40 std_5_41 std_5_42 std_5_43 std_5_44 std_5_45 std_5_46 std_5_47);
egen zscore_6=rowmean( std_6_1 std_6_2 std_6_3 std_6_4 std_6_5 std_6_6 std_6_7 std_6_8 std_6_9 std_6_10 std_6_11 std_6_12 std_6_13 std_6_14 std_6_15 std_6_16 std_6_17 std_6_18 std_6_19 std_6_20 std_6_21 std_6_22 std_6_23 std_6_24 std_6_25);
	
foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12{;
	reg  zscore_`num' `full', robust;
	estimates store tab3_col4_h`num';
};
	estout tab3_col4_h* using "tab3_col4", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;

	estimates drop _all;


*/----------------------------------------------------------------
  #9. TABLE 3 COL 5: Drop Attriters
 	- Endline data ONLY
	- Minimal controls ONLY
	- Using Z-score approach to ME Index (Kling, Liebman & Katz 2007) 
	- Full sample outcomes ONLY
	- Drop replacement HHS and individuals 
------------------------------------------------------------------/;

use "gbf_analysis_noattriters.dta", clear;

drop if post==0;

foreach num of numlist 1 2 3 4 7 8 9 10 11 12{;
	local i = `num';
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		local zscore_string_`i'="`zscore_string_`i''" + " std_`i'_`l'";
			};
	qui egen zscore_`i'=rowmean(`zscore_string_`i'');
	local zscore_string_`i'="";
	local l = 0;
	drop *_mean *_sd mean_std_*;
	};

foreach num of numlist 5 6{;
	local i = `num';
	foreach var of varlist  `p_me_corevars_`i'' `e_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		};
	local l = 0;
	drop *_mean *_sd mean_std_*;
	};

egen zscore_5=rowmean( std_5_1 std_5_2 std_5_3 std_5_4 std_5_5 std_5_6 std_5_7 std_5_8 std_5_9 std_5_10 std_5_11 std_5_12 std_5_13 std_5_14 std_5_15 std_5_16 std_5_17 std_5_18 std_5_19 std_5_20 std_5_21 std_5_22 std_5_23 std_5_24 std_5_25 std_5_26 std_5_27 std_5_28 std_5_29 std_5_30 std_5_31 std_5_32 std_5_33 std_5_34 std_5_35 std_5_36 std_5_37 std_5_38 std_5_39 std_5_40 std_5_41 std_5_42 std_5_43 std_5_44 std_5_45 std_5_46 std_5_47);
egen zscore_6=rowmean( std_6_1 std_6_2 std_6_3 std_6_4 std_6_5 std_6_6 std_6_7 std_6_8 std_6_9 std_6_10 std_6_11 std_6_12 std_6_13 std_6_14 std_6_15 std_6_16 std_6_17 std_6_18 std_6_19 std_6_20 std_6_21 std_6_22 std_6_23 std_6_24 std_6_25);
	
foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12{;
	reg  zscore_`num' t tothhs road ward_*, robust;
	estimates store tab3_col5_h`num';
};
	estout tab3_col5_h* using "tab3_col5", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;

	estimates drop _all;


*/----------------------------------------------------------------
	# 10. TABLE 3 COL 6: Mean effects on all outcomes (add in conditional outcomes)
	- Endline data ONLY
	- Minimal controls ONLY
	- Using SUR approach to ME Index (Kling & Liebman 2004)
	- Full sample AND CONDITIONAL outcomes 
------------------------------------------------------------------/;

use "gbf_analysis.dta", clear;

keep if post==1;

foreach num of numlist 1 3 7 9 11 12{;
	local i = `num'; 	
	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};

	qui suest `suest_string_`i'';

	local n=wordcount("`p_me_allvars_`i''");
	local m=wordcount("`e_me_allvars_`i''");
	local k = `n' + `m';
		forvalues p = 1/`k'{;
		local nlcom_string_`i'="`nlcom_string_`i''" + "`plus'" + "[e`p'_mean]t";
		local plus = " +";
			};
	nlcom ((`nlcom_string_`i'')/`k'), post;

	estimates store me_all_h`i';
	drop *_mean *_sd *_std;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	};

estout me_all_h* using "tab3_col6", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
estimates drop _all;

*** Rerun for H2 with large # of all outcomes;
use "gbf_analysis.dta", clear;
keep if post==1;
local i = 2; 

	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
		
		qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t+[e34_mean]t+[e35_mean]t) /35), post;
	estimates store me_all_h`i';
	estout me_all_h`i' using "tab3_col6_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;	
	
*** Rerun for H4 with large # of all outcomes;
use "gbf_analysis.dta", clear;
keep if post==1;
local i = 4; 

	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
		
		qui suest `suest_string_`i'', vce(cluster id_vill);

		nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t+[e34_mean]t+[e35_mean]t+[e36_mean]t+[e37_mean]t+[e38_mean]t+[e39_mean]t+[e40_mean]t+[e41_mean]t+[e42_mean]t+[e43_mean]t+[e44_mean]t+[e45_mean]t+[e46_mean]t+[e47_mean]t+[e48_mean]t+[e49_mean]t+[e50_mean]t+[e51_mean]t+[e52_mean]t+[e53_mean]t+[e54_mean]t + [e55_mean]t+ [e56_mean]t+ [e57_mean]t+[e58_mean]t + [e59_mean]t+ [e60_mean]t+ [e61_mean]t+ [e62_mean]t) /62), post;
	
	estimates store me_all_h`i';
	estout me_all_h`i' using "tab3_col6_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;	


*** Rerun for H5 with large # of all outcomes;
use "gbf_analysis.dta", clear;
keep if post==1;
local i = 5; 

	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
		
	qui suest e1 e2 e3 e4 e5 e6 e7 e8 e9 e10 e11 e12 e13 e14 e15 e16 e17 e18 e19 e20 e21 e22 e23 e24 e25 e26 e27 e28 e29 e30 e31 e32 e33 e34 e35 e36 e37 e38 e39 e40 e41 e42 e43 e44 e45 e46 e47 e48 e49 e50 e51 e52 e53 e54 e55 e56 e57 e58 e59 e60 e61 e62 e63 e64 e65 e66 e67 e68 e69 e70 e71 e72 e73 e74 e75 e76 e77 e78 e79 e80 e81 e82, vce(cluster id_vill);
	nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t+[e34_mean]t+[e35_mean]t+[e36_mean]t+[e37_mean]t+[e38_mean]t+[e39_mean]t+[e40_mean]t+[e41_mean]t+[e42_mean]t+[e43_mean]t+[e44_mean]t+[e45_mean]t+[e46_mean]t+[e47_mean]t+[e48_mean]t+[e49_mean]t+[e50_mean]t+[e51_mean]t+[e52_mean]t+[e53_mean]t+[e54_mean]t + [e55_mean]t+ [e56_mean]t+ [e57_mean]t+ [e58_mean]t +[e59_mean]t+[e60_mean]t+[e61_mean]t+[e62_mean]t+[e63_mean]t+[e64_mean]t+[e65_mean]t+[e66_mean]t+[e67_mean]t+[e68_mean]t+[e69_mean]t + [e70_mean]t+ [e71_mean]t+ [e72_mean]t+[e73_mean]t+[e74_mean]t+[e75_mean]t+[e76_mean]t+[e77_mean]t+[e78_mean]t+[e79_mean]t + [e80_mean]t+ [e81_mean]t+ [e82_mean]t) /82), post;

	estimates store me_all_h`i';
	estout me_all_h`i' using "tab3_col6_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;	
	
	
*** Rerun for H6 with large # of all outcomes;
use "gbf_analysis.dta", clear;
keep if post==1;
local i = 6;	
	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
		
		qui suest `suest_string_`i'', vce(cluster id_vill);

		nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t) /29), post;

	estimates store me_all_h`i';
	estout me_all_h`i' using "tab3_col6_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;	

*** Rerun for H8 with large # of all outcomes;
use "gbf_analysis.dta", clear;
keep if post==1;
local i = 8;	
	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
		
		qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t+[e34_mean]t+[e35_mean]t+[e36_mean]t+[e37_mean]t+[e38_mean]t+[e39_mean]t+[e40_mean]t+[e41_mean]t+[e42_mean]t+[e43_mean]t+[e44_mean]t+[e45_mean]t+[e46_mean]t)/46), post;

	estimates store me_all_h`i';
	estout me_all_h`i' using "tab3_col6_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;		
	
	
*** Rerun for H10 with large # of all outcomes;
use "gbf_analysis.dta", clear;
keep if post==1;
local i = 10;	
	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
		
		qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t+[e34_mean]t+[e35_mean]t+[e36_mean]t+[e37_mean]t+[e38_mean]t+[e39_mean]t+[e40_mean]t+[e41_mean]t+[e42_mean]t)/42), post;
	estimates store me_all_h`i';
	estout me_all_h`i' using "tab3_col6_h`i'", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;		
	

*/----------------------------------------------------------------
	#11. TABLE 3 Column 7. 2005 'Purist' approach to ME Index 
	- Endline data ONLY
	- Minimal controls ONLY
	- Using Z-score approach to ME Index (Kling, Liebman & Katz 2007)
	- Full sample outcomes ONLY
	- Limit hypos to those detailed in 2005 document
	- Limit outcomes under each of 2005 hypos to those collected in baseline
		note that H2 and H4 originally combined, separated here for comparability
------------------------------------------------------------------/;

use "gbf_analysis.dta", clear;

drop if post==0;

foreach num of numlist 2 3 4 5 6 7 8 9 10 11 {;
	local i = `num';
	foreach var of varlist  `p_me_corevars_`i''{;
		local l = `l' + 1;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen std_`i'_`l'=(`var'-`var'_mean)/`var'_sd;
		qui egen mean_std_`i'_`l'_t=mean( std_`i'_`l') if t==1;
		qui replace std_`i'_`l'=mean_std_`i'_`l'_t if t==1 & std_`i'_`l'==.;
		qui replace std_`i'_`l'=0 if t==0 & std_`i'_`l'==.;
		local zscore_string_`i'="`zscore_string_`i''" + " std_`i'_`l'";
			};
	egen zscore_`i'=rowmean(`zscore_string_`i'');
	local zscore_string_`i'="";
	local l = 0;
	drop *_mean *_sd mean_std_*;
	};
	
foreach num of numlist 2 3 4 5 6 7 8 9 10 11 {;
	reg  zscore_`num' t tothhs road ward_*, robust;
	estimates store tab3_col7_h`num';
};
	estout tab3_col7_* using "tab3_col7", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;

	estimates drop _all;
	
	
*/----------------------------------------------------------------
	#12. Tables 4, 5 and 6 - Selected individual outcome treatment effects
	- Minimal controls
	- Endline only
	- For tables of Signif TEs (Tab4), SCAs (Tab5), Cherry Picking (Tab6)
	- NOTE: outcome tarp appears in both tables 5 and 6, TE estimated only once below under tab 5
------------------------------------------------------------------/;

use "gbf_analysis.dta", clear;
keep if post==1;

foreach num of numlist 40 50 60 {;
	local i = `num'; 
	foreach var of varlist `allvars_`i'' {;
			reg  `var'  `min', robust;
			estimates store tab`i'_`var';
			qui gen te_`var'=_b[t];
			qui gen se_`var'=_se[t];
			qui gen p_`var'=2*(1-normal(abs(te_`var'/ se_`var')));
			sum `var' if t==0;
			qui gen cm_`var'=r(mean);
			qui egen N_`var'=count(`var');
		};
	};
	
		
			
	estout tab* using "tab4_5_6", cells(b(star fmt(%9.2f)) se(par fmt(%9.2f))) stats(N r2, fmt( %9.0f %9.2f)) starlevels(+ .1 * .05 ** .01) replace;
	estimates drop tab*;
gen n=_n;
keep if n==1;
keep n te_* se_* p_* cm* N_*;
reshape long te_ se_ p_ cm_ N_, i(n) j(x) string;
rename x outcome;
rename te treatment_effect;
rename se std_error;
rename cm_ controlmean;
gen table=.;

foreach x of local allvars_40 {;
	qui replace table=4 if outcome=="`x'";
	};
	
foreach x of local allvars_50 {;
	qui replace table=5 if outcome=="`x'";
	};
	
foreach x of local allvars_60 {;
	qui replace table=6 if outcome=="`x'";
	};
sort table;
list table outcome  controlmean  treat std p_ N;

*** Table 5 Supplement: Estimate Mean Effects by SCA field activities (using SUR approach in KLK 2004 to accomodate conditional outcomes);

* NOTE: variable know_cards was not in PAP and was included in SCA ME1 by mistake (Tab 5, row 1) - included again here for accuracy of replication;

use "gbf_analysis.dta", clear;
keep if post==1;
foreach num of numlist 1 3  {;
	local i = `num'; 	
	foreach var of varlist `core_sca`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	local k=wordcount("`core_sca`i''");
		forvalues p = 1/`k'{;
		local nlcom_string_`i'="`nlcom_string_`i''" + "`plus'" + "[e`p'_mean]t";
		local plus = " +";
			};
	nlcom ((`nlcom_string_`i'')/`k'), post;
	estimates store sca_me_`i';
	estout sca_me_`i' using "tab5_me_sca`i'", cells(b(star fmt(%9.2f)) se(par fmt(%9.2f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;
};

	
*** Rerun for SCA2 with large number of outcomes;	
use "gbf_analysis.dta", clear;
keep if post==1;

	local i = 2; 	
	foreach var of varlist `core_sca`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui gen `var'_std=(`var'-`var'_mean)/`var'_sd;
		qui reg `var'_std `min';
		local j = `j' + 1;
		estimates store e`j';
		local suest_string_`i'="`suest_string_`i''" + " e`j'";
		};
	qui suest `suest_string_`i'', vce(cluster id_vill);

	nlcom (([e1_mean]t+[e2_mean]t+[e3_mean]t+[e4_mean]t+[e5_mean]t+[e6_mean]t+[e7_mean]t+[e8_mean]t+[e9_mean]t+[e10_mean]t+[e11_mean]t+[e12_mean]t+[e13_mean]t+[e14_mean]t+[e15_mean]t+[e16_mean]t+[e17_mean]t+[e18_mean]t+[e19_mean]t+[e20_mean]t+[e21_mean]t+[e22_mean]t+[e23_mean]t+[e24_mean]t+[e25_mean]t+[e26_mean]t+[e27_mean]t+[e28_mean]t+[e29_mean]t+[e30_mean]t+[e31_mean]t+[e32_mean]t+[e33_mean]t) /33), post;

	estimates store sca_me_`i';
	estout sca_me_`i' using "tab5_me_sca`i'", cells(b(star fmt(%9.2f)) se(par fmt(%9.2f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
	local j = 0;
	local plus="";
	local suest_string_`i'="";
	local nlcom_string_`i'="";
	estimates drop _all;
	drop *_mean *_sd *_std;


*/----------------------------------------------------------------
	#13. Appendix F: Baseline treatment vs control, all outcomes
------------------------------------------------------------------/;


use "gbf_analysis.dta", clear;
keep if post==0;

* Generate placeholders;
foreach var of varlist  cards-other_out{;
	qui gen h_`var'="";
	qui gen o_`var'="";
	qui gen fa_`var'="";
	qui gen te_`var'=.;
	qui gen se_`var'=.;
	qui gen p_`var'=.;
	qui gen N_`var'=.;
	qui gen tm_`var'=.;
	qui gen cm_`var'=.;
	};

* Calculate stats;

* NOTE: the p-value formula below is an approximation, accuracy verified through inspection of log file;
foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12 {;
	local i = `num'; 
	foreach var of varlist `p_me_allvars_`i''{;
		areg `var' t tothhs road, absorb(r_ward) robust;
		qui replace te_`var'=_b[t];
		qui replace se_`var'=_se[t];
		qui replace p_`var'=2*(1-normal(abs(te_`var'/ se_`var')));
		qui replace N_`var'=e(N);
		ttest `var', by(t);
		replace cm_`var'=r(mu_1);
		};
	};
gen n=_n;
keep if n==1;


* Identify hypothesis #s;
foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12 {;
	local i = `num'; 
		foreach var of varlist `p_me_allvars_`i''{;
		qui replace h_`var'=h_`var' + ", H`i'" if h_`var'!="";
		qui replace h_`var'="H`i'" if h_`var'=="";
		qui replace o_`var'="`i'" if o_`var'=="";
		};
	};

* Reshape and tidy;
keep n te_* se_* p_* N_* cm_* h_* o_*;
reshape long te_ se_ p_ N_ cm_ h_ o_, i(n) j(x) string;
drop n; 
qui  gen signif=.;
qui replace signif=.90 if  p_<.1;
qui replace signif=.95 if  p_<.05;
qui replace signif=.99 if  p_<.01;
drop p_;
order  x cm_ te_ se_ signif N_ h_;
format  %9.3f te se cm ;
drop if h_=="";
destring o_, replace;

rename x variable;
rename  te_ treat_effect_base;
rename  se_ treat_stderr_base;
rename  cm_ mean_control_base;
rename  N_ N_base;
rename  h_ hypo;
gsort o_ hypo variable;
drop o_;
outsheet using "appendix_f", replace;
list;


*/----------------------------------------------------------------
  #14. APPENDIX G: Attrition from Panel across T/C assignment
------------------------------------------------------------------/;

use "gbf_hhs_attrition.dta", clear;
keep if post==0;
foreach var of varlist female youth anyeduc meet_com assets{;
	gen `var'_t=`var'*t;
	};

reg panel1 t, robust cluster(id_vill);
estimates store attrit_1;
reg panel1 female youth anyeduc meet_com assets t female_t youth_t anyeduc_t meet_com_t assets_t, robust cluster(id_vill);
estimates store attrit_2;
reg panel2 t, robust cluster(id_vill);
estimates store attrit_3;
reg panel2 female youth anyeduc meet_com assets t female_t youth_t anyeduc_t meet_com_t assets_t, robust cluster(id_vill);
estimates store attrit_4;

estout attrit_* using "appendix_G", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;
sum panel1;
sum panel2;

*/----------------------------------------------------------------
  #15. APPENDIX H: Validation of SCAs
------------------------------------------------------------------/;

* 1A. SCA Validation - Baseline LPG and endline vouchers/CA;
use "gbf_analysis.dta", clear;
keep if post==1;
keep id_vill cards bombali tothhs;
save "sca_validation.dta", replace;

use "gbf_analysis.dta", clear;
keep if post==0;
keep id_vill f_* t;
		
*Note: these 9 goods meet the following criteria: (i) available in baseline, (ii) more than 2% of villages have the good in 2005;
egen count_lpg=rowtotal(f_psch f_phu f_well f_relig f_dryflr f_grnstr f_comcntr f_barrie f_palava);
merge 1:1 id_vill using "sca_validation.dta";
reg cards count_lpg, robust;
estimates store scavalid_lpg1;


* 1B. SCA Validation - Baseline women/youth meeting attendance/part and same in endline SCA salt/batt;
use "gbf_analysis.dta", clear;
keep if post==1;
keep id_vill meet_wmn meet_yth meet_tot spkr_wmn spkr_yth spkr_tot t;
save "sca_validation2.dta", replace;

use "gbf_hhs_attrition.dta", clear;
keep if post==0;
* proportions from baseline;
gen batt_wom=meet_com if female==1;
gen batt_yth=meet_com if youth==1;
gen bspk_wom=spk_com if female==1;
gen bspk_yth=spk_com if youth==1;
* numbers from baseline;
bys id_vill: egen btot_fem=total(female);
bys id_vill: egen btot_bspk_wom=total(bspk_wom);
bys id_vill: egen btot_batt_wom=total(batt_wom);
bys id_vill: egen btot_yth=total(youth);
bys id_vill: egen btot_bspk_yth=total(bspk_yth);
bys id_vill: egen btot_batt_yth=total(batt_yth);
collapse btot_* bombali tothhs, by(id_vill);

merge 1:1 id_vill using "sca_validation2.dta";
reg meet_wmn btot_batt_wom btot_fem meet_tot, robust;
estimates store scavalid_spk1;
reg meet_yth btot_batt_yth btot_yth meet_tot, robust;
estimates store scavalid_spk2;
reg spkr_wmn btot_bspk_wom btot_fem meet_wmn, robust;
estimates store scavalid_spk3;
reg spkr_yth btot_bspk_yth btot_yth meet_yth, robust;
estimates store scavalid_spk4;

estout scavalid_* using "appendix_H", cells(b(star fmt(%9.3f)) se(par fmt(%9.3f))) stats(N, fmt( %9.0f %9.2f)) style(fixed) starlevels(+ .1 * .05 ** .01) replace;

erase "sca_validation.dta";
erase "sca_validation2.dta";


*/----------------------------------------------------------------
  #16. APPENDIX J: Raw results for all outcomes (Cols 1-7, 10)
   	- Endline data ONLY
	- Minimal controls ONLY
------------------------------------------------------------------/;

*** 1. Calculate treatment effects and control group means;

use "gbf_analysis.dta", clear;
keep if post==1;

foreach var of varlist  cards- other_out{;
	qui gen h_`var'="";
	qui gen o_`var'="";
	qui gen g_`var'="conditional";
	qui gen te_`var'=.;
	qui gen se_`var'=.;
	qui gen p_`var'=.;
	qui gen N_`var'=.;
	qui gen cm_`var'=.;
	qui gen s_`var'="";
	};

foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12 {;
	local i = `num'; 
	foreach var of varlist `p_me_allvars_`i'' `e_me_allvars_`i''{;
		areg `var' t tothhs road, absorb(r_ward) robust;
		qui replace te_`var'=_b[t];
		qui replace se_`var'=_se[t];
		qui replace p_`var'=2*(1-normal(abs(te_`var'/ se_`var')));
		qui replace N_`var'=e(N);
		ttest `var', by(t);
		qui replace cm_`var'=r(mu_1);
		};
	};
gen n=_n;
keep if n==1;


*** 2. Classify by hypo, full sample/conditional and SCA;


* A. Flag core as opposed to additional (conditional) outcomes;
foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12 {;
	local i = `num'; 
	foreach var of varlist `p_me_corevars_`i'' `e_me_corevars_`i''{;
		qui replace g_`var'="full sample";
		};
	};


* B. Identify Hypothesis;
foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12 {;
	local i = `num'; 
		foreach var of varlist `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui replace h_`var'=h_`var' + ", H`i'" if h_`var'!="";
		qui replace h_`var'="H`i'" if h_`var'=="";
		qui replace o_`var'="`i'" if o_`var'=="";
		};
	};

* C. Flag those from SCAs;
foreach num of numlist 1 2 3 {;
	local i = `num'; 
	foreach var of varlist `core_sca`i''{;
		qui replace s_`var'="SCA #`i'";
		};
	};
		
	
keep n te_* se_* p_* N_* cm_* h_* g_* o_* s_*;
reshape long te_ se_ p_ N_ cm_ h_ g_ o_ s_, i(n) j(x) string;
drop n; 
gen signif=.;
replace signif=.90 if  p_<.1;
replace signif=.95 if  p_<.05;
replace signif=.99 if  p_<.01;
replace signif=. if x=="vote" | x=="vh_youth"; * Note: p-val formula is an approximation, TE for these 2 outcomes NOT signif at 10% (is at 10.1%);
order  x cm_ te_ se_ signif N_ h_ g_ p_;
format  %9.3f te se cm;
drop if h_=="";
destring o_, replace;
gsort o_ - g_ x;

rename x variable;
rename  te_ treat_effect;
rename  se_ treat_stderr;
rename  cm_ mean_control;
rename  N_ N;
rename  h_ hypo;
rename g_ me_group;
rename o_ order;
rename p_ est_pc_pval;
qui gen row=_n;
outsheet using "appendix_J", replace;


*** Appendix J columns 1 - 7, 10;
* Note: per comp p-values are estimates, and not exact;
list row variable hypo me_group s_ mean_control treat_effect treat_stderr signif est_pc_pval N;
	

*/----------------------------------------------------------------
  #17. APPENDIX J, COL 8  - Raw results FWER p-values by hypothesis
  - Note this is not stable, so will not return exactly the same results when rerun
  - Code adapted from Anderson 2008
------------------------------------------------------------------/;


* 1. Adjust macros: cf_grnstr footequip deleted as cannot standardize since all C obs = 0;

	local p_allvars_1 "vdc vis_wdc vis_lc met_councilor att_wdc";
	local e_allvars_1 "vdp bank_acct wdc_psch wdc_phu wdc_tba wdc_well wdc_dryflr wdc_grnstr wdc_comctr wdc_latrine wdc_sports";
	* NOTE on ME 2 ALL: dropped financial contributions to phu and market as do not have sufficient obsrvations to support complete control set;
	local p_allvars_2 "f_psch f_phu f_well f_dryflr f_grnstr f_comctr f_market proposal cf_psch cf_well cf_dryflr cf_comctr";
	local e_allvars_2 "f_latrine func_tba func_sports seedbank footunif tarp_public no_bush days_brush smat_psch smat_lat smat_dry smat_well qual_psch qual_lat qual_dry qual_well  cf_latrine fin_tba fin_sports card_public";
	local p_allvars_3 "petty betteroff assets quintile tot_sources market_prod";
	local e_allvars_3 "bank_acct tot_petty tot_goods tot_newbiz income training newbiz sold_agric sold_other  ag_income school_days agric_out other_out";
	local p_allvars_7 "trust_own trust_out trust_chf trust_lc trust_cg osusu hwallet hmarket rmarket";
	local e_allvars_7 "trust_ngo mkt_grp rwallet";
	local p_allvars_4 "wkcomfrm brush vdc proposal commfarm  commtchr train tchrpay tchrmoney  cf_psch cf_well cf_dryflr cf_comctr daysfrm  bmon_osu bmon_lab bmon_pta lab_lab lab_pta";
	local e_allvars_4 "vchr_tot vchr_self anycard cards bmon_soc bmon_sav lab_osu lab_soc lab_sav cf_latrine fin_tba fin_sports  lab_psch lab_phu lab_tba lab_well lab_dryflr lab_grnstr lab_comctr lab_latrine lab_sports  mat_psch mat_phu mat_tba mat_well mat_dryflr mat_grnstr mat_comctr mat_latrine mat_sports tarp tarp_freq mkt_grp no_bush days_brush used_cards mat_back qual";
	local p_allvars_8 "ttch_oth osusu mbr_lab mbr_pta mbr_soc ttch_own  meet_osu  meet_lab meet_pta bmon_osu bmon_lab bmon_pta lab_lab lab_pta";
 	local e_allvars_8 "mbr_sav meet_soc meet_sav bmon_soc bmon_sav lab_osu lab_soc lab_sav mbr_fish mbr_seed mbr_wom mbr_youth meet_fish meet_seed meet_wom meet_youth bmon_fish bmon_seed bmon_wom bmon_youth lab_fish lab_seed lab_wom lab_youth fishcoop mkt_grp"; 
	local p_allvars_9 "name_lc name_chr name_sc name_pc name_elec name_tax name_proj radio name_dues vis_wdc vis_lc disp_ind";
	local e_allvars_9 "gift_meet gift_two gift_choice info_gift tarp_used know_cards info_tarp info_cards vis_pc";
	local p_allvars_5 "meet_com meet_osu meet_lab meet_pta meet_tchr meet_farm spk_com spk_tchr spk_farm"; 
	local e_allvars_5 "gift_meet proj_dem gift_dem gift_say tarp_say gift_big meet_soc meet_sav mtng_salt mtng_tarp mtng_cards dem_salt dem_tarp dem_cards say_salt say_tarp say_cards spk_salt spk_tarp spk_cards mtng_psch mtng_phu mtng_tba mtng_well mtng_dryflr mtng_grnstr mtng_comctr mtng_latrine mtng_sports meet_tot meet_wmn meet_yth  spkr_tot spkr_wmn spkr_yth vote debate nohanghd noprivol democ  role_wmn role_yth duration maj_gift inc_hh pwy_hh meet_salt equal_salt meet_tarp equal_tarp meet_cards equal_cards minutes disabled_meet disabled_ldr show_tarp store_tarp nocorrupt rcpt_cards recd_cards goods_show show_mat store_mat meet_fish meet_seed meet_wom meet_youth"; 
	local p_allvars_10 "vote_pres1 vote_local met_councilor att_wdc change_council change_chiefdom stand_pc stand_sc stand_lc stand_wdc vdc"; 
	local e_allvars_10 "vote_pres2 discuss_politics council_listen vote_pres_card1 vote_pres_card2 vote_local_card wannabe_VDC chf_psch chf_phu chf_tba chf_well chf_dryflr chf_grnstr chf_comctr chf_latrine chf_sports wdc_psch wdc_phu wdc_tba wdc_well wdc_dryflr wdc_grnstr wdc_comctr wdc_latrine wdc_sports vdc_wmn vdc_yth vdc_wy vdp vdp_writ vdp_tarp vdp_mat"; 
	local p_allvars_11 "nomon_conflict no_theft no_fight no_witch nomon_violence"; 
	local e_allvars_11 "violence_bad nobeatwife nobeatchild no_conflict resolve_within"; 
	local p_allvars_6 "resolve_nottrad trust_lc_chf tchr_dec tchr_rep"; 
	local e_allvars_6 "gift_say tarp_public question_auth leader_wmn leader_yth proj_dem spend_lc_chf list_lc_chf notchf_salt notrad_salt notchf_tarp notrad_tarp notchf_cards notrad_cards vote chf_consult tstore_notchf mstore_pub send_not_trad not_trad_salt not_trad_tarp not_trad_card gift_who tarp_say tarp_stored"; 
	local p_allvars_12 "osusu_ind labgang_ind frm_sex frm_age frm_nokid frm_trb"; 
	local e_allvars_12 "nobeatwife leader_yth leader_wmn bribebad strangeok noforcework youthtreat socialc_ind groupsave_ind vh_fem vh_youth rvh_fem rvh_youth"; 

foreach num of numlist 1 2 3 4 5 6 7 8 9 10 11 12 {;
	use "gbf_analysis.dta", clear;
	drop if post==0;

local i = `num';

	foreach var of varlist  `p_me_allvars_`i'' `e_me_allvars_`i''{;
		qui sum `var' if t==0;
		qui gen `var'_mean=r(mean);
		qui gen `var'_sd=r(sd);
		qui replace `var'=(`var'-`var'_mean)/`var'_sd;
			};
	drop *_mean *_sd ;

keep `p_me_allvars_`i'' `e_me_allvars_`i'' t tothhs road ward_*;

* generate variables to store actual and simulated t-stats/p-vals ;

local counter = 1;
qui gen str20 varname = "";
qui gen float tstat = .;
qui gen float act_pval = .;
qui gen float tstatsim = .;
qui gen float pvalsim = .;
qui gen float pvals = .;

* run the original regressions for all of the different outcomes tested and store the actual (observed) p-vals/t-stats;

foreach lhsvar in  `p_me_allvars_`i'' `e_me_allvars_`i'' {;
    quietly reg `lhsvar' t tothhs road ward_*;
    quietly replace tstat = abs(_b[t]/_se[t]) in `counter';
    quietly replace act_pval = 2*ttail(e(N),abs(tstat)) in `counter';
    quietly replace varname = "`lhsvar'" in `counter';
    local `lhsvar'_ct_0 = 0;
    local counter = `counter' + 1;
    };

* sort the p-vals by the actual (observed) p-vals (this will reorder some of the obs, but that shouldn't matter);

gsort act_pval;
local endvar = `counter' - 1;

* generate the variable that will contain the simulated (placebo) treatments;

gen byte simtreatment = .;
gen float simtreatment_uni = .;
local count = 1;

* run 10,000 iterations of the simulation, record results in p-val storage counters;
while `count' <= 10000 {;
* in this section we assign the placebo treatments and run regressions using the placebo treatments;
	quietly replace simtreatment_uni = uniform();
	quietly replace simtreatment = (simtreatment_uni>0.5);
	quietly replace tstatsim = .;
	quietly replace pvalsim = .;
	foreach lhsvar of numlist 1/`endvar' {;
	    local depvar = varname[`lhsvar'];
        quietly reg `depvar' simtreatment tothhs road ward_*;
	* NOTE: I am adding in the controls, but not robust;
    	quietly replace tstatsim = abs(_b[simtreatment]/_se[simtreatment]) in `lhsvar';
        quietly replace pvalsim = 2*ttail(e(N),abs(tstatsim)) in `lhsvar';
    	};
* in this section we perform the "step down" procedure that replaces simulated p-vals with the minimum of the set of simulated p-vals associated with outcomes that had actual p-vals greater than or equal to the one being replaced.  For each outcome, we keep count of how many times the ultimate simulated p-val is less than the actual observed p-val.;
    local countdown = `endvar';
    while `countdown' >= 1 {;
        quietly replace pvalsim = min(pvalsim,pvalsim[_n+1]) in `countdown';
        local depvar = varname[`countdown'];
        if pvalsim[`countdown'] <= act_pval[`countdown'] {;
            local `depvar'_ct_0 = ``depvar'_ct_0' + 1;
            };
        local countdown = `countdown' - 1;
    	};
    local count = `count' + 1;
    };

* perform the final adjustment that ensures that the ordering to adjusted p-vals is the same as the original ordering of actual p-vals.  note that this is actually a "step up" procedure rather than a "step down";
foreach lhsvar of numlist 1/`endvar' {;
    local depvar = varname[`lhsvar'];
    quietly replace pvals = max(round(``depvar'_ct_0'/10000,.001), pvals[`lhsvar'-1]) in `lhsvar';
    };	
display "Hypothesis number = `num'";
list varname pvals if varname!="";
};	


*/----------------------------------------------------------------
  #18. APPENDIX J COL 9 - FDR q-values by hypothesis
  - Code from Michael Anderson (see http://are.berkeley.edu/~mlanderson)
 ------------------------------------------------------------------/;

* MANUALLY run "fdr_sharpened_qvalues" by hypothesis;
* Paste in estimated per comparison p-vals from #17 outsheet file;

capture log close;

